//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 四元数テストヘッダ
 * @author Junpee
 */

#ifndef QUATERNION_TEST_H_
#define QUATERNION_TEST_H_

#include <LampUnit/TestCase.h>

namespace Lamp{
	class Quaternion;
}

//------------------------------------------------------------------------------
/**
 * 四元数テスト
 */
class QuaternionTest : public TestCase{
public:
	/**
	 * コンストラクタ
	 * @param name テストの名前
	 */
	explicit QuaternionTest(String name);

	/**
	 * テストを実行する
	 */
	virtual void runTest(){}

	/**
	 * テストスィートの取得
	 * @return テストスィート
	 */
	static Test* suite();

	// コンストラクタテスト
	virtual void testConstructor();

	// 定数テスト
	virtual void testFixedNumber();

	// 値の設定テスト
	virtual void testSetValue();

	// 回転テスト
	virtual void testRotation();

	// XYZオイラー回転テスト
	virtual void testEulerRotationXYZ();

	// ZYXオイラー回転テスト
	virtual void testEulerRotationZYX();

	// 演算テスト
	virtual void testArithmetic();

	// 代入演算テスト
	virtual void testSubstitutionArithmetic();

	// 長さテスト
	virtual void testLength();

	// 四元数演算テスト
	virtual void testQuaternion();

	// 補間テスト
	virtual void testInterpolate();

	// 論理演算テスト
	virtual void testLogicalOperation();

	// 文字列テスト
	virtual void testToString();

private:
	// Direct3D四元数との比較
	bool d3dEquals(D3DXQUATERNION& d3d, Quaternion& quat);

	// Direct3D四元数との比較
	bool d3dEpsilonEquals(D3DXQUATERNION& d3d, Quaternion& quat, float epsilon);

};

//------------------------------------------------------------------------------
#endif // End of QUATERNION_TEST_H_
//------------------------------------------------------------------------------
